/*
 * Example tasks.
 *
 * Copyright (C) 2015, 2016 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "board.h"
#include "lcd.h"
#include "jzlcd.h"
#include "tasks.h"

extern vidinfo_t panel_info;

void next_pixel(unsigned short *x, unsigned short *y)
{
	(*x)++;
	if (*x >= panel_info.vl_col) {
		*x = 0;
		(*y)++;
		if (*y >= panel_info.vl_row)
			*y = 0;
	}
}

void plot_value(u32 value)
{
	unsigned short x, y;

	while (1)
	{
		for (y = 0; y < panel_info.vl_row; y++)
		{
			for (x = 0; x < panel_info.vl_col; x++)
			{
				set_pixel(x, y, get_bitmap_value(x, value));
			}
		}
	}
}

/* Tasks. */

void plot_pattern(unsigned short pixel_type, unsigned short x, unsigned short y)
{
	int i;

	while (1) {
		test_pixel(x, y, pixel_type);
		next_pixel(&x, &y);
		for (i = 0; i < 10000; i++);
	}
}

void start_plot_pattern(unsigned short task)
{
	u32 args[] = {task, 0, (task * (panel_info.vl_row / 4)) % panel_info.vl_row};

	start_task(task, (void (*)()) plot_pattern, args, 3);
}
